#include <jni.h>
#include <windows.h>

HANDLE hand [2];
volatile int first, close;

JNIEXPORT jboolean JNICALL Java_music_index_windows_1native_WindowsFilesystemChangeMonitor_nativeInit
  (JNIEnv * je, jobject jo, jstring jpath) {
  const char * path;
  const DWORD notify = FILE_NOTIFY_CHANGE_FILE_NAME |
				FILE_NOTIFY_CHANGE_DIR_NAME |
				FILE_NOTIFY_CHANGE_LAST_WRITE;
  path = (*je)->GetStringUTFChars( je, jpath, NULL );
  first = 1;
  close = 0;
  
  hand[0] = CreateEvent (NULL, TRUE, FALSE, NULL);
  hand[1] = FindFirstChangeNotification (path,TRUE,notify);
  
  (*je)->ReleaseStringUTFChars(je, jpath, path);
  
  if (hand[1]==INVALID_HANDLE_VALUE)
	return JNI_FALSE;
  else 
	return JNI_TRUE;
  }
  
JNIEXPORT void JNICALL Java_music_index_windows_1native_WindowsFilesystemChangeMonitor_nativeWaitForChange
  (JNIEnv * je, jobject jo) {
  if (first != 0) {
	first = 0;
  }
  else {
	FindNextChangeNotification (hand[1]);
	}
  WaitForMultipleObjects (2, hand, FALSE, INFINITE);
  if (close == 1) {
	CloseHandle (hand[0]);
	FindCloseChangeNotification (hand[1]);
	}
  }
  

JNIEXPORT void JNICALL Java_music_index_windows_1native_WindowsFilesystemChangeMonitor_nativeStop
  (JNIEnv * je, jobject jo) {
	close = 1;
	SetEvent (hand[0]);
  }
  